BEGIN{
	seq_lines = "";
}
/saved_cs_client/{next};
/character_set_client/{next};
/LOCK TABLE/{ next};
/INSERT INTO "table_where_data_unimportant" /{ next};
{


if ($0 ~ /INSERT INTO/ || $0 ~ /insert into/ ) { in_insert = 1;}

# remove unnecessary or inappropriate escapes
# fix others
if (in_insert){ 
	gsub(/\\r/,"");
	gsub(/<\/p>\\n\\n/, "</p>");
	gsub(/<p>\\n\\n/, "<p>");
	gsub(/<[bB][rR][\/]*>\\n/, "<br/>");
	gsub(/\\n/, "<br/>");
	gsub(/\\"/, "\"");
        sub(/\\');$/, "PROTECTED_END_SLASH");
	gsub(/\\'/, "''");
        sub("PROTECTED_END_SLASH$", "\\');");

}

if ($0 ~ /CREATE TABLE/ ) { table_name = $3; gsub(/\"/, "", table_name);}

if ( !in_insert && $0 ~ /enum/ ){
	# enums become create type statements
	#CREATE TYPE mood AS ENUM ('sad', 'ok', 'happy');
	enum=data=$0;
	gsub(/^[ 	]*"/,"", enum);
	gsub(/" .*$/, "", enum);
	gsub(/^[ 	]*".*" enum\(/, "(", data);
	gsub(/\).*$/, ");", data);
	print "DROP TYPE " enum "_enum ;"
	print "CREATE TYPE " enum "_enum AS ENUM " data;

	gsub(/enum\(.*\)/, enum"_enum");
}

if ( $0 ~ /AUTO_INCREMENT/ || $0 ~ /auto_increment/ )
{
	# Create a script to create the lines to be run to set next values
	# correctly:
        # ALTER SEQUENCE <table>_<column>_seq RESTART WITH <prior>;
	col_name = $1; gsub(/\"/, "", col_name);
	seq_lines = seq_lines"SELECT 'ALTER SEQUENCE "table_name"_"col_name"_seq RESTART WITH '||max("col_name")+1||';' FROM "table_name";\n"

	# change the line appropriately
	gsub(/ AUTO_INCREMENT/, "");
	gsub(/ auto_increment/, "");
	gsub(/int\([5-9]\)/, "serial");
	gsub(/int\(1[0-9]\)/, "bigserial");
}

# need to handle autoincrement first
gsub(/tinyint\(.*\)/, "smallint");
gsub(/mediumint\(.*\)/, "integer");
gsub(/int\([0-4]\)/, "smallint");
gsub(/int\([5-9]\)/, "integer");
gsub(/int\(1[0-9]\)/, "bigint");
gsub(/" double/, "\" double precision");



#datetime '0000-00-00 00:00:00'
gsub(/datetime/, "timestamp");

gsub(/0000-00-00/,"1970-01-01");

gsub(/DEFAULT CURRENT_TIMESTAMP/, "DEFAULT CURRENT_TIMESTAMP(0)");

# this is handled in code
gsub(/ON UPDATE CURRENT_TIMESTAMP/, "");
gsub(/on update CURRENT_TIMESTAMP/, "");

# handle "KEY" statements by making indexes
# forum: CREATE UNIQUE INDEX name ON table (column [, ...]);
if ( $0 ~ /^[ 	]*[UNIQUE ]*KEY/ ) {
	if ( $0 ~ /^[ 	]*UNIQUE KEY/ ) { unique=1; }
	gsub(/^[ 	]*[UNIQUE ]*KEY/, "");
	if ( $0 ~ /,$/ ){
		gsub(/,$/, "");
	} else {
		# for some reason matching wasn't reliable
		# for removing comma at end of statement
		l=length(statement);
		statement = substr(statement, 1, l-2);
	}
	keyname=$1
	gsub(/\"/, "", keyname);
	$1="";
	index_line = index_line "\nCREATE " (unique? "UNIQUE" : "") " INDEX \"" table_name"_"keyname"\" on " table_name " " $0";";
	unique=0;
	keyname="";
} else {
	statement=statement$0"\n";
}
}
/;/{
print statement;
print index_line;
table_name=statement=index_line="";
in_insert=0;
}
END{ 
print seq_lines; 
}
